## hinge 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(AwAssembler)

set(libexec "lib/hinge")
add_subdirectory(src bin)

install(
DIRECTORY scripts/
DESTINATION ${libexec}
USE_SOURCE_PERMISSIONS
)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

#if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
#    set(WINDOWS TRUE)
#elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
#    set(LINUX TRUE)
#    message( "Linux Detected, using gcc48")
#    set(CMAKE_C_COMPILER /usr/bin/gcc-4.8)
#    set(CMAKE_CXX_COMPILER /usr/bin/g++-4.8)
#elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#    set(MACOSX TRUE)
#    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/build")
#    message( "OS X Detected, using gcc49")
#    set(CMAKE_C_COMPILER /usr/local/bin/gcc-4.9)
#    set(CMAKE_CXX_COMPILER /usr/local/bin/g++-4.9)
#    set(CMAKE_INCLUDE_CURRENT_DIR ON)
#    set(CMAKE_AUTOMOC ON)
#endif()



set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -std=gnu++11")
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fopenmp")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")

include_directories(include)

## Libraries

add_subdirectory(lib lib)

add_subdirectory(spdlog)

#add_subdirectory(ogdf)

find_program(PANDOC pandoc)

if(PANDOC)
  add_custom_command(
    OUTPUT hinge.1
    COMMAND ${PANDOC} --from markdown --to man -s ${CMAKE_CURRENT_SOURCE_DIR}/hinge.1.md -o hinge.1
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hinge.1.md
    VERBATIM
    )

  add_custom_target(man ALL DEPENDS hinge.1)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/hinge.1 DESTINATION share/man/man1)
endif()

install(PROGRAMS hinge DESTINATION bin)

## Executables

add_subdirectory(filter filter)

add_subdirectory(maximal maximal)

add_subdirectory(consensus consensus)

add_subdirectory(layout layout)

## Tests

add_subdirectory(test)

=== src/consensus/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

add_executable(draft_assembly draft)
target_link_libraries(draft_assembly LAInterface ini falcon spdlog)

add_executable(consensus consensus.cpp)
target_link_libraries(consensus LAInterface falcon ini)

install(TARGETS draft_assembly consensus DESTINATION ${libexec})

=== src/filter/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

add_executable(Reads_filter filter)
target_link_libraries(Reads_filter LAInterface ini spdlog)

install(TARGETS Reads_filter DESTINATION ${libexec})

=== src/layout/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(Boost_USE_STATIC_LIBS   ON)

FIND_PACKAGE( Boost COMPONENTS graph REQUIRED )
INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIR} )

add_executable(hinging hinging)
target_link_libraries(hinging LAInterface ini spdlog ${Boost_LIBRARIES})

install(TARGETS hinging DESTINATION ${libexec})

=== src/lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

add_library(ini ini.c INIReader.cpp)
add_library(DB DB.c QV.c)
add_library(LA align.c)

add_library(PAF paf.c)
find_package( ZLIB REQUIRED )
if ( ZLIB_FOUND )
    include_directories( ${ZLIB_INCLUDE_DIRS} )
    target_link_libraries( PAF ${ZLIB_LIBRARIES} )
endif( ZLIB_FOUND )

add_library(LAInterface LAInterface.cpp)
target_link_libraries(LAInterface LA DB PAF)


add_library(kmer_lookup kmer_lookup.c)
add_library(DW_banded DW_banded.c)
add_library(falcon falcon.c)
target_link_libraries(falcon kmer_lookup DW_banded)

=== src/maximal/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

add_executable(get_maximal_reads maximal)
target_link_libraries(get_maximal_reads LAInterface ini spdlog)

install(TARGETS get_maximal_reads DESTINATION ${libexec})

=== src/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

=== debian/changelog ===
hinge (0.5.0-8) unstable; urgency=medium

  [ Komolehin Israel Timilehin ]
  * Document dependency installation errors
  * Removed installation error log
  * Added Autopkgtest
  * Updated depends
  * Replicate upstream demo
  * Added README to document error

  [ Andreas Tille ]
  * Standards-Version: 4.7.2 (routine-update)
  * Fix build with CMake 4
    Closes: #1112992
  * d/watch: version=5
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 19:03:17 +0200

hinge (0.5.0-7) unstable; urgency=medium

  * Packaging update
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * No tab in license text (routine-update)
  * No need to exclude files any more in d/copyright

 -- Andreas Tille <tille@debian.org>  Wed, 22 Dec 2021 08:21:12 +0100

hinge (0.5.0-6) unstable; urgency=medium

  [ Gilles Filippini ]
  * Fix FTBFS against spdlog 1.5.0 (closes: #952615)

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

 -- Andreas Tille <tille@debian.org>  Thu, 19 Mar 2020 18:18:50 +0100

hinge (0.5.0-5) unstable; urgency=medium

  * Afif removed himself from Uploaders
  * Add myself to Uploaders
  * Use 2to3 to port to Python3
    Closes: #936704
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 06 Dec 2019 16:12:32 +0100

hinge (0.5.0-4) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

  [ Michael R. Crusoe ]
  * Remove trailing whitespace in debian/copyright
  * Added libspdlog-dev 1:1.3.0 compatibility, Closes: #909763
  * Standards-Version: 4.3.0, no changes needed
  * debhelper 12

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 18 Jan 2019 11:03:09 -0800

hinge (0.5.0-3) unstable; urgency=low

  * Mark spdlog patch as forwarded upstream
  * d/control: copy Depends into Build-Depends
    to allow migration to Testing
  * Bump Standards-Version to 4.1.3
  * Bump copyright year

 -- Afif Elghraoui <afif@debian.org>  Sun, 04 Feb 2018 14:07:59 -0500

hinge (0.5.0-2) unstable; urgency=medium

  * Team upload.
  * d/p/libspdlog: Update to new interface, Closes: #884211
  * d/control: Update to standards 4.1.1 (no changes needed)

 -- Gert Wollny <gewo@debian.org>  Wed, 13 Dec 2017 12:23:29 +0100

hinge (0.5.0-1) unstable; urgency=medium

  * Initial release (Closes: #878962)

 -- Afif Elghraoui <afif@debian.org>  Fri, 20 Oct 2017 00:27:38 -0400

=== debian/control ===
Source: hinge
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libspdlog-dev,
 libboost-dev,
 libboost-graph-dev,
 libhdf5-dev,
 zlib1g-dev,
 pandoc,
# Run-Time-Depends:
# (to prevent building where not installable)
 python3,
 daligner,
 dazzdb,
 dascrubber,
 python3-numpy,
 python3-ujson,
 python3-colormap,
 python3-pbcore,
 python3-networkx,
 python3-matplotlib,
Vcs-Browser: https://salsa.debian.org/med-team/hinge
Vcs-Git: https://salsa.debian.org/med-team/hinge.git
Homepage: https://github.com/HingeAssembler/HINGE
Rules-Requires-Root: no

Package: hinge
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python3,
 daligner,
 dazzdb,
 dascrubber,
 python3-numpy,
 python3-ujson,
 python3-colormap,
 python3-pbcore,
 python3-networkx,
 python3-matplotlib,
Description: long read genome assembler based on hinging
 HINGE is a genome assembler that seeks to achieve optimal repeat resolution
 by distinguishing repeats that can be resolved given the data from those that
 cannot. This is accomplished by adding “hinges” to reads for constructing an
 overlap graph where only unresolvable repeats are merged. As a result, HINGE
 combines the error resilience of overlap-based assemblers with
 repeat-resolution capabilities of de Bruijn graph assemblers.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_installexamples:
	dh_installexamples
	# only install nominal.ini from the utils/ directory, but preserve
	# the directory structure (since demo scripts expect it)
	mkdir -p debian/hinge/usr/share/doc/hinge/examples/utils \
	&& cp utils/nominal.ini debian/hinge/usr/share/doc/hinge/examples/utils

=== debian/tests/control ===
# FIXME: The test is deactivated since not yet finished
#Tests: run-demo
#Depends: wget, hinge, seqtk
#Restrictions: allow-stderr, needs-internet

=== debian/watch ===
Version: 5

Template: Github
Owner: HingeAssembler
Project: HINGE
